<?php

namespace WebApiV4;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'authentication' => '\\WebApiV4\\StructType\\Authentication',
            'applicationError' => '\\WebApiV4\\StructType\\ApplicationError',
            'AbonnementsoortV4' => '\\WebApiV4\\StructType\\AbonnementsoortV4',
            'AbonnementV4' => '\\WebApiV4\\StructType\\AbonnementV4',
            'AboInfoRecV4' => '\\WebApiV4\\StructType\\AboInfoRecV4',
            'AboObjectV4' => '\\WebApiV4\\StructType\\AboObjectV4',
            'AboPakketAanvProdV4' => '\\WebApiV4\\StructType\\AboPakketAanvProdV4',
            'AboPakketAboSoortV4' => '\\WebApiV4\\StructType\\AboPakketAboSoortV4',
            'AboPakketV4' => '\\WebApiV4\\StructType\\AboPakketV4',
            'AboRelatieV4' => '\\WebApiV4\\StructType\\AboRelatieV4',
            'ActieV4' => '\\WebApiV4\\StructType\\ActieV4',
            'AdresObjectV4' => '\\WebApiV4\\StructType\\AdresObjectV4',
            'CalamiteitV4' => '\\WebApiV4\\StructType\\CalamiteitV4',
            'CreditcardV4' => '\\WebApiV4\\StructType\\CreditcardV4',
            'EditieV4' => '\\WebApiV4\\StructType\\EditieV4',
            'FactuurAdresV4' => '\\WebApiV4\\StructType\\FactuurAdresV4',
            'FactSamenvatBtwV4' => '\\WebApiV4\\StructType\\FactSamenvatBtwV4',
            'FactSamenvatSubtotV4' => '\\WebApiV4\\StructType\\FactSamenvatSubtotV4',
            'FactSamenvatV4' => '\\WebApiV4\\StructType\\FactSamenvatV4',
            'HerkomstV4' => '\\WebApiV4\\StructType\\HerkomstV4',
            'KenmerkV4' => '\\WebApiV4\\StructType\\KenmerkV4',
            'KlachtV4' => '\\WebApiV4\\StructType\\KlachtV4',
            'LicentiehouderV4' => '\\WebApiV4\\StructType\\LicentiehouderV4',
            'PersoonsObjectV4' => '\\WebApiV4\\StructType\\PersoonsObjectV4',
            'PropositiesV4' => '\\WebApiV4\\StructType\\PropositiesV4',
            'PropositieObjectV4' => '\\WebApiV4\\StructType\\PropositieObjectV4',
            'PropositiePremiumsV4' => '\\WebApiV4\\StructType\\PropositiePremiumsV4',
            'RolV4' => '\\WebApiV4\\StructType\\RolV4',
            'SearchAbonnementResultV4' => '\\WebApiV4\\StructType\\SearchAbonnementResultV4',
            'ToekMutV4' => '\\WebApiV4\\StructType\\ToekMutV4',
            'UitgaveObjectV4' => '\\WebApiV4\\StructType\\UitgaveObjectV4',
            'UitgaveV4' => '\\WebApiV4\\StructType\\UitgaveV4',
            'VerbandV4' => '\\WebApiV4\\StructType\\VerbandV4',
            'VerschInfoV4' => '\\WebApiV4\\StructType\\VerschInfoV4',
            'VrijeVeldenAboRecV4' => '\\WebApiV4\\StructType\\VrijeVeldenAboRecV4',
            'VrijCodeveldAboRecV4' => '\\WebApiV4\\StructType\\VrijCodeveldAboRecV4',
            'VrijDatumveldAboRecV4' => '\\WebApiV4\\StructType\\VrijDatumveldAboRecV4',
            'VrijTekstveldAboRecV4' => '\\WebApiV4\\StructType\\VrijTekstveldAboRecV4',
            'VrijVeldCodeV4' => '\\WebApiV4\\StructType\\VrijVeldCodeV4',
            'VrijVeldDatumV4' => '\\WebApiV4\\StructType\\VrijVeldDatumV4',
            'VrijVeldTekstV4' => '\\WebApiV4\\StructType\\VrijVeldTekstV4',
            'AbonnementsoortInfoV4' => '\\WebApiV4\\StructType\\AbonnementsoortInfoV4',
            'AbonnementInfoV4' => '\\WebApiV4\\StructType\\AbonnementInfoV4',
            'AbonnementTabV4' => '\\WebApiV4\\StructType\\AbonnementTabV4',
            'AboInfoTabV4' => '\\WebApiV4\\StructType\\AboInfoTabV4',
            'AboPakketAanvProdInfoV4' => '\\WebApiV4\\StructType\\AboPakketAanvProdInfoV4',
            'AboPakketAboSoortInfoV4' => '\\WebApiV4\\StructType\\AboPakketAboSoortInfoV4',
            'AboPakketInfoV4' => '\\WebApiV4\\StructType\\AboPakketInfoV4',
            'ActieInfoV4' => '\\WebApiV4\\StructType\\ActieInfoV4',
            'CalamiteitTabV4' => '\\WebApiV4\\StructType\\CalamiteitTabV4',
            'EditieInfoV4' => '\\WebApiV4\\StructType\\EditieInfoV4',
            'FactSamenvatBtwInfoV4' => '\\WebApiV4\\StructType\\FactSamenvatBtwInfoV4',
            'FactSamenvatInfoV4' => '\\WebApiV4\\StructType\\FactSamenvatInfoV4',
            'FactSamenvatSubtotInfoV4' => '\\WebApiV4\\StructType\\FactSamenvatSubtotInfoV4',
            'HerkomstInfoV4' => '\\WebApiV4\\StructType\\HerkomstInfoV4',
            'KenmerkInfoV4' => '\\WebApiV4\\StructType\\KenmerkInfoV4',
            'KlachtTabV4' => '\\WebApiV4\\StructType\\KlachtTabV4',
            'LeverbareProductenInfoV4' => '\\WebApiV4\\StructType\\LeverbareProductenInfoV4',
            'LicentiehouderInfoV4' => '\\WebApiV4\\StructType\\LicentiehouderInfoV4',
            'PropositieInfoV4' => '\\WebApiV4\\StructType\\PropositieInfoV4',
            'PropositiePremiumsTabV4' => '\\WebApiV4\\StructType\\PropositiePremiumsTabV4',
            'PropositieTabV4' => '\\WebApiV4\\StructType\\PropositieTabV4',
            'RelatieNummerObjectV4' => '\\WebApiV4\\StructType\\RelatieNummerObjectV4',
            'RolInfoV4' => '\\WebApiV4\\StructType\\RolInfoV4',
            'ToekMutInfoV4' => '\\WebApiV4\\StructType\\ToekMutInfoV4',
            'UitgaveInfoV4' => '\\WebApiV4\\StructType\\UitgaveInfoV4',
            'VerbandInfoV4' => '\\WebApiV4\\StructType\\VerbandInfoV4',
            'VerschInfoTabV4' => '\\WebApiV4\\StructType\\VerschInfoTabV4',
            'getUitgaveInfoRequest' => '\\WebApiV4\\StructType\\GetUitgaveInfoRequest',
            'getUitgaveInfoResponse' => '\\WebApiV4\\StructType\\GetUitgaveInfoResponse',
            'getAbonnementsoortInfoRequest' => '\\WebApiV4\\StructType\\GetAbonnementsoortInfoRequest',
            'getAbonnementsoortInfoResponse' => '\\WebApiV4\\StructType\\GetAbonnementsoortInfoResponse',
            'getPakketInfoRequest' => '\\WebApiV4\\StructType\\GetPakketInfoRequest',
            'getPakketInfoResponse' => '\\WebApiV4\\StructType\\GetPakketInfoResponse',
            'getActieInfoRequest' => '\\WebApiV4\\StructType\\GetActieInfoRequest',
            'getActieInfoResponse' => '\\WebApiV4\\StructType\\GetActieInfoResponse',
            'getPropositieInfoRequest' => '\\WebApiV4\\StructType\\GetPropositieInfoRequest',
            'getPropositieInfoResponse' => '\\WebApiV4\\StructType\\GetPropositieInfoResponse',
            'getAbonnementInfoRequest' => '\\WebApiV4\\StructType\\GetAbonnementInfoRequest',
            'getAbonnementInfoResponse' => '\\WebApiV4\\StructType\\GetAbonnementInfoResponse',
            'searchAbonnementRequest' => '\\WebApiV4\\StructType\\SearchAbonnementRequest',
            'searchAbonnementResponse' => '\\WebApiV4\\StructType\\SearchAbonnementResponse',
            'searchAbonnementByCredRequest' => '\\WebApiV4\\StructType\\SearchAbonnementByCredRequest',
            'searchAbonnementByCredResponse' => '\\WebApiV4\\StructType\\SearchAbonnementByCredResponse',
            'searchSmartcodeRequest' => '\\WebApiV4\\StructType\\SearchSmartcodeRequest',
            'searchSmartcodeResponse' => '\\WebApiV4\\StructType\\SearchSmartcodeResponse',
            'getRelatieAbosoortPrijsRequest' => '\\WebApiV4\\StructType\\GetRelatieAbosoortPrijsRequest',
            'getRelatieAbosoortPrijsResponse' => '\\WebApiV4\\StructType\\GetRelatieAbosoortPrijsResponse',
            'checkProefaboRequest' => '\\WebApiV4\\StructType\\CheckProefaboRequest',
            'checkProefaboResponse' => '\\WebApiV4\\StructType\\CheckProefaboResponse',
            'createAboAboNawRequest' => '\\WebApiV4\\StructType\\CreateAboAboNawRequest',
            'createAboAboNawResponse' => '\\WebApiV4\\StructType\\CreateAboAboNawResponse',
            'createAboAboNoRequest' => '\\WebApiV4\\StructType\\CreateAboAboNoRequest',
            'createAboAboNoResponse' => '\\WebApiV4\\StructType\\CreateAboAboNoResponse',
            'createAboDebNawAboNawRequest' => '\\WebApiV4\\StructType\\CreateAboDebNawAboNawRequest',
            'createAboDebNawAboNawResponse' => '\\WebApiV4\\StructType\\CreateAboDebNawAboNawResponse',
            'createAboDebNawAboNoRequest' => '\\WebApiV4\\StructType\\CreateAboDebNawAboNoRequest',
            'createAboDebNawAboNoResponse' => '\\WebApiV4\\StructType\\CreateAboDebNawAboNoResponse',
            'createAboDebNoAboNawRequest' => '\\WebApiV4\\StructType\\CreateAboDebNoAboNawRequest',
            'createAboDebNoAboNawResponse' => '\\WebApiV4\\StructType\\CreateAboDebNoAboNawResponse',
            'createAboDebNoAboNoRequest' => '\\WebApiV4\\StructType\\CreateAboDebNoAboNoRequest',
            'createAboDebNoAboNoResponse' => '\\WebApiV4\\StructType\\CreateAboDebNoAboNoResponse',
            'createVervolgAbonnementRequest' => '\\WebApiV4\\StructType\\CreateVervolgAbonnementRequest',
            'createVervolgAbonnementResponse' => '\\WebApiV4\\StructType\\CreateVervolgAbonnementResponse',
            'updateAboBetaalwijzeRequest' => '\\WebApiV4\\StructType\\UpdateAboBetaalwijzeRequest',
            'updateAboBetaalwijzeResponse' => '\\WebApiV4\\StructType\\UpdateAboBetaalwijzeResponse',
            'updateAboPasswordRequest' => '\\WebApiV4\\StructType\\UpdateAboPasswordRequest',
            'updateAboPasswordResponse' => '\\WebApiV4\\StructType\\UpdateAboPasswordResponse',
            'updateLicentieRequest' => '\\WebApiV4\\StructType\\UpdateLicentieRequest',
            'updateLicentieResponse' => '\\WebApiV4\\StructType\\UpdateLicentieResponse',
            'createVakantieRegelingRequest' => '\\WebApiV4\\StructType\\CreateVakantieRegelingRequest',
            'createVakantieRegelingResponse' => '\\WebApiV4\\StructType\\CreateVakantieRegelingResponse',
            'createVerhuizingRequest' => '\\WebApiV4\\StructType\\CreateVerhuizingRequest',
            'createVerhuizingResponse' => '\\WebApiV4\\StructType\\CreateVerhuizingResponse',
            'createBezorgKlachtRequest' => '\\WebApiV4\\StructType\\CreateBezorgKlachtRequest',
            'createBezorgKlachtResponse' => '\\WebApiV4\\StructType\\CreateBezorgKlachtResponse',
            'createBezKlachtRelUitgaveRequest' => '\\WebApiV4\\StructType\\CreateBezKlachtRelUitgaveRequest',
            'createBezKlachtRelUitgaveResponse' => '\\WebApiV4\\StructType\\CreateBezKlachtRelUitgaveResponse',
            'getCalamiteitInfoRequest' => '\\WebApiV4\\StructType\\GetCalamiteitInfoRequest',
            'getCalamiteitInfoResponse' => '\\WebApiV4\\StructType\\GetCalamiteitInfoResponse',
            'getCalamiteitInfoByPcHnrRequest' => '\\WebApiV4\\StructType\\GetCalamiteitInfoByPcHnrRequest',
            'getCalamiteitInfoByPcHnrResponse' => '\\WebApiV4\\StructType\\GetCalamiteitInfoByPcHnrResponse',
            'getHerkomstInfoRequest' => '\\WebApiV4\\StructType\\GetHerkomstInfoRequest',
            'getHerkomstInfoResponse' => '\\WebApiV4\\StructType\\GetHerkomstInfoResponse',
            'searchRelNoByAboNoRequest' => '\\WebApiV4\\StructType\\SearchRelNoByAboNoRequest',
            'searchRelNoByAboNoResponse' => '\\WebApiV4\\StructType\\SearchRelNoByAboNoResponse',
            'searchRelNoByEmailRequest' => '\\WebApiV4\\StructType\\SearchRelNoByEmailRequest',
            'searchRelNoByEmailResponse' => '\\WebApiV4\\StructType\\SearchRelNoByEmailResponse',
            'createKlantPersoonRequest' => '\\WebApiV4\\StructType\\CreateKlantPersoonRequest',
            'createKlantPersoonResponse' => '\\WebApiV4\\StructType\\CreateKlantPersoonResponse',
            'updateKlantPersoonRequest' => '\\WebApiV4\\StructType\\UpdateKlantPersoonRequest',
            'updateKlantPersoonResponse' => '\\WebApiV4\\StructType\\UpdateKlantPersoonResponse',
            'updateKlantAdresRequest' => '\\WebApiV4\\StructType\\UpdateKlantAdresRequest',
            'updateKlantAdresResponse' => '\\WebApiV4\\StructType\\UpdateKlantAdresResponse',
            'updateKlantPasswordRequest' => '\\WebApiV4\\StructType\\UpdateKlantPasswordRequest',
            'updateKlantPasswordResponse' => '\\WebApiV4\\StructType\\UpdateKlantPasswordResponse',
            'getVerbandInfoRequest' => '\\WebApiV4\\StructType\\GetVerbandInfoRequest',
            'getVerbandInfoResponse' => '\\WebApiV4\\StructType\\GetVerbandInfoResponse',
            'createVerbandR1nawR2nawRequest' => '\\WebApiV4\\StructType\\CreateVerbandR1nawR2nawRequest',
            'createVerbandR1nawR2nawResponse' => '\\WebApiV4\\StructType\\CreateVerbandR1nawR2nawResponse',
            'createVerbandR1nawR2noRequest' => '\\WebApiV4\\StructType\\CreateVerbandR1nawR2noRequest',
            'createVerbandR1nawR2noResponse' => '\\WebApiV4\\StructType\\CreateVerbandR1nawR2noResponse',
            'createVerbandR1noR2nawRequest' => '\\WebApiV4\\StructType\\CreateVerbandR1noR2nawRequest',
            'createVerbandR1noR2nawResponse' => '\\WebApiV4\\StructType\\CreateVerbandR1noR2nawResponse',
            'createVerbandR1noR2noRequest' => '\\WebApiV4\\StructType\\CreateVerbandR1noR2noRequest',
            'createVerbandR1noR2noResponse' => '\\WebApiV4\\StructType\\CreateVerbandR1noR2noResponse',
            'deleteVerbandRequest' => '\\WebApiV4\\StructType\\DeleteVerbandRequest',
            'deleteVerbandResponse' => '\\WebApiV4\\StructType\\DeleteVerbandResponse',
            'getKenmerkInfoRequest' => '\\WebApiV4\\StructType\\GetKenmerkInfoRequest',
            'getKenmerkInfoResponse' => '\\WebApiV4\\StructType\\GetKenmerkInfoResponse',
            'getKlantKenmerkRequest' => '\\WebApiV4\\StructType\\GetKlantKenmerkRequest',
            'getKlantKenmerkResponse' => '\\WebApiV4\\StructType\\GetKlantKenmerkResponse',
            'createKlantKenmerkRequest' => '\\WebApiV4\\StructType\\CreateKlantKenmerkRequest',
            'createKlantKenmerkResponse' => '\\WebApiV4\\StructType\\CreateKlantKenmerkResponse',
            'deleteKlantKenmerkRequest' => '\\WebApiV4\\StructType\\DeleteKlantKenmerkRequest',
            'deleteKlantKenmerkResponse' => '\\WebApiV4\\StructType\\DeleteKlantKenmerkResponse',
            'getSwitchPropositiesRequest' => '\\WebApiV4\\StructType\\GetSwitchPropositiesRequest',
            'getSwitchPropositiesResponse' => '\\WebApiV4\\StructType\\GetSwitchPropositiesResponse',
            'switchAbonnementRequest' => '\\WebApiV4\\StructType\\SwitchAbonnementRequest',
            'switchAbonnementResponse' => '\\WebApiV4\\StructType\\SwitchAbonnementResponse',
            'getPostcodeInfoRequest' => '\\WebApiV4\\StructType\\GetPostcodeInfoRequest',
            'getPostcodeInfoResponse' => '\\WebApiV4\\StructType\\GetPostcodeInfoResponse',
            'getLeverbareProductenInfoRequest' => '\\WebApiV4\\StructType\\GetLeverbareProductenInfoRequest',
            'getLeverbareProductenInfoResponse' => '\\WebApiV4\\StructType\\GetLeverbareProductenInfoResponse',
            'wijkCheckRequest' => '\\WebApiV4\\StructType\\WijkCheckRequest',
            'wijkCheckResponse' => '\\WebApiV4\\StructType\\WijkCheckResponse',
            'getRolInfoRequest' => '\\WebApiV4\\StructType\\GetRolInfoRequest',
            'getRolInfoResponse' => '\\WebApiV4\\StructType\\GetRolInfoResponse',
            'addLicentiehouderRolRequest' => '\\WebApiV4\\StructType\\AddLicentiehouderRolRequest',
            'addLicentiehouderRolResponse' => '\\WebApiV4\\StructType\\AddLicentiehouderRolResponse',
            'updateLicentiehouderRolRequest' => '\\WebApiV4\\StructType\\UpdateLicentiehouderRolRequest',
            'updateLicentiehouderRolResponse' => '\\WebApiV4\\StructType\\UpdateLicentiehouderRolResponse',
            'deleteLicentiehouderRolRequest' => '\\WebApiV4\\StructType\\DeleteLicentiehouderRolRequest',
            'deleteLicentiehouderRolResponse' => '\\WebApiV4\\StructType\\DeleteLicentiehouderRolResponse',
            'getLicentiehoudersRequest' => '\\WebApiV4\\StructType\\GetLicentiehoudersRequest',
            'getLicentiehoudersResponse' => '\\WebApiV4\\StructType\\GetLicentiehoudersResponse',
            'addLicentiehouderRequest' => '\\WebApiV4\\StructType\\AddLicentiehouderRequest',
            'addLicentiehouderResponse' => '\\WebApiV4\\StructType\\AddLicentiehouderResponse',
            'deleteLicentiehouderRequest' => '\\WebApiV4\\StructType\\DeleteLicentiehouderRequest',
            'deleteLicentiehouderResponse' => '\\WebApiV4\\StructType\\DeleteLicentiehouderResponse',
            'stopGratisAboPerDirectRequest' => '\\WebApiV4\\StructType\\StopGratisAboPerDirectRequest',
            'stopGratisAboPerDirectResponse' => '\\WebApiV4\\StructType\\StopGratisAboPerDirectResponse',
            'getFactSamenvatInfoRequest' => '\\WebApiV4\\StructType\\GetFactSamenvatInfoRequest',
            'getFactSamenvatInfoResponse' => '\\WebApiV4\\StructType\\GetFactSamenvatInfoResponse',
            'getToekomstigeMutatiesRequest' => '\\WebApiV4\\StructType\\GetToekomstigeMutatiesRequest',
            'getToekomstigeMutatiesResponse' => '\\WebApiV4\\StructType\\GetToekomstigeMutatiesResponse',
            'deleteToekomstigeMutatieRequest' => '\\WebApiV4\\StructType\\DeleteToekomstigeMutatieRequest',
            'deleteToekomstigeMutatieResponse' => '\\WebApiV4\\StructType\\DeleteToekomstigeMutatieResponse',
            'cancelBezorgKlachtRequest' => '\\WebApiV4\\StructType\\CancelBezorgKlachtRequest',
            'cancelBezorgKlachtResponse' => '\\WebApiV4\\StructType\\CancelBezorgKlachtResponse',
            'getEditiesRequest' => '\\WebApiV4\\StructType\\GetEditiesRequest',
            'getEditiesResponse' => '\\WebApiV4\\StructType\\GetEditiesResponse',
            'bestaatActiefAbonnementRequest' => '\\WebApiV4\\StructType\\BestaatActiefAbonnementRequest',
            'bestaatActiefAbonnementResponse' => '\\WebApiV4\\StructType\\BestaatActiefAbonnementResponse',
            'setOptInOutRequest' => '\\WebApiV4\\StructType\\SetOptInOutRequest',
            'setOptInOutResponse' => '\\WebApiV4\\StructType\\SetOptInOutResponse',
            'renewAbonnementRequest' => '\\WebApiV4\\StructType\\RenewAbonnementRequest',
            'renewAbonnementResponse' => '\\WebApiV4\\StructType\\RenewAbonnementResponse',
        );
    }
}
