<?php

namespace WebApiV4\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AboPakketAanvProdInfoV4 StructType
 * Meta informations extracted from the WSDL
 * - documentation: Lijst met onderliggende aanvullende producten onder dit pakket.
 * @subpackage Structs
 * @date 20190723
 * @package WebApiV4
 */
class AboPakketAanvProdInfoV4 extends AbstractStructBase
{
    /**
     * The aboPakketAanvProd
     * Meta informations extracted from the WSDL
     * - documentation: Lijst met onderliggende aanvullende producten onder dit pakket.
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: false
     * @var \WebApiV4\StructType\AboPakketAanvProdV4[]
     */
    public $aboPakketAanvProd;
    /**
     * Constructor method for AboPakketAanvProdInfoV4
     * @uses AboPakketAanvProdInfoV4::setAboPakketAanvProd()
     * @param \WebApiV4\StructType\AboPakketAanvProdV4[] $aboPakketAanvProd
     */
    public function __construct(array $aboPakketAanvProd = array())
    {
        $this
            ->setAboPakketAanvProd($aboPakketAanvProd);
    }
    /**
     * Get aboPakketAanvProd value
     * @return \WebApiV4\StructType\AboPakketAanvProdV4[]|null
     */
    public function getAboPakketAanvProd()
    {
        return $this->aboPakketAanvProd;
    }
    /**
     * This method is responsible for validating the values passed to the setAboPakketAanvProd method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAboPakketAanvProd method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAboPakketAanvProdForArrayConstraintsFromSetAboPakketAanvProd(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $aboPakketAanvProdInfoV4AboPakketAanvProdItem) {
            // validation for constraint: itemType
            if (!$aboPakketAanvProdInfoV4AboPakketAanvProdItem instanceof \WebApiV4\StructType\AboPakketAanvProdV4) {
                $invalidValues[] = is_object($aboPakketAanvProdInfoV4AboPakketAanvProdItem) ? get_class($aboPakketAanvProdInfoV4AboPakketAanvProdItem) : sprintf('%s(%s)', gettype($aboPakketAanvProdInfoV4AboPakketAanvProdItem), var_export($aboPakketAanvProdInfoV4AboPakketAanvProdItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The aboPakketAanvProd property can only contain items of type \WebApiV4\StructType\AboPakketAanvProdV4, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set aboPakketAanvProd value
     * @throws \InvalidArgumentException
     * @param \WebApiV4\StructType\AboPakketAanvProdV4[] $aboPakketAanvProd
     * @return \WebApiV4\StructType\AboPakketAanvProdInfoV4
     */
    public function setAboPakketAanvProd(array $aboPakketAanvProd = array())
    {
        // validation for constraint: array
        if ('' !== ($aboPakketAanvProdArrayErrorMessage = self::validateAboPakketAanvProdForArrayConstraintsFromSetAboPakketAanvProd($aboPakketAanvProd))) {
            throw new \InvalidArgumentException($aboPakketAanvProdArrayErrorMessage, __LINE__);
        }
        $this->aboPakketAanvProd = $aboPakketAanvProd;
        return $this;
    }
    /**
     * Add item to aboPakketAanvProd value
     * @throws \InvalidArgumentException
     * @param \WebApiV4\StructType\AboPakketAanvProdV4 $item
     * @return \WebApiV4\StructType\AboPakketAanvProdInfoV4
     */
    public function addToAboPakketAanvProd(\WebApiV4\StructType\AboPakketAanvProdV4 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \WebApiV4\StructType\AboPakketAanvProdV4) {
            throw new \InvalidArgumentException(sprintf('The aboPakketAanvProd property can only contain items of type \WebApiV4\StructType\AboPakketAanvProdV4, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->aboPakketAanvProd[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \WebApiV4\StructType\AboPakketAanvProdInfoV4
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
