<?php

namespace WebApiV4\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AboPakketAboSoortInfoV4 StructType
 * Meta informations extracted from the WSDL
 * - documentation: Lijst met onderliggende abonnementsoorten onder dit pakket.
 * @subpackage Structs
 * @date 20190723
 * @package WebApiV4
 */
class AboPakketAboSoortInfoV4 extends AbstractStructBase
{
    /**
     * The aboPakketAboSoort
     * Meta informations extracted from the WSDL
     * - documentation: Lijst met onderliggende abonnementsoorten onder dit pakket.
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: false
     * @var \WebApiV4\StructType\AboPakketAboSoortV4[]
     */
    public $aboPakketAboSoort;
    /**
     * Constructor method for AboPakketAboSoortInfoV4
     * @uses AboPakketAboSoortInfoV4::setAboPakketAboSoort()
     * @param \WebApiV4\StructType\AboPakketAboSoortV4[] $aboPakketAboSoort
     */
    public function __construct(array $aboPakketAboSoort = array())
    {
        $this
            ->setAboPakketAboSoort($aboPakketAboSoort);
    }
    /**
     * Get aboPakketAboSoort value
     * @return \WebApiV4\StructType\AboPakketAboSoortV4[]|null
     */
    public function getAboPakketAboSoort()
    {
        return $this->aboPakketAboSoort;
    }
    /**
     * This method is responsible for validating the values passed to the setAboPakketAboSoort method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAboPakketAboSoort method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAboPakketAboSoortForArrayConstraintsFromSetAboPakketAboSoort(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $aboPakketAboSoortInfoV4AboPakketAboSoortItem) {
            // validation for constraint: itemType
            if (!$aboPakketAboSoortInfoV4AboPakketAboSoortItem instanceof \WebApiV4\StructType\AboPakketAboSoortV4) {
                $invalidValues[] = is_object($aboPakketAboSoortInfoV4AboPakketAboSoortItem) ? get_class($aboPakketAboSoortInfoV4AboPakketAboSoortItem) : sprintf('%s(%s)', gettype($aboPakketAboSoortInfoV4AboPakketAboSoortItem), var_export($aboPakketAboSoortInfoV4AboPakketAboSoortItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The aboPakketAboSoort property can only contain items of type \WebApiV4\StructType\AboPakketAboSoortV4, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set aboPakketAboSoort value
     * @throws \InvalidArgumentException
     * @param \WebApiV4\StructType\AboPakketAboSoortV4[] $aboPakketAboSoort
     * @return \WebApiV4\StructType\AboPakketAboSoortInfoV4
     */
    public function setAboPakketAboSoort(array $aboPakketAboSoort = array())
    {
        // validation for constraint: array
        if ('' !== ($aboPakketAboSoortArrayErrorMessage = self::validateAboPakketAboSoortForArrayConstraintsFromSetAboPakketAboSoort($aboPakketAboSoort))) {
            throw new \InvalidArgumentException($aboPakketAboSoortArrayErrorMessage, __LINE__);
        }
        $this->aboPakketAboSoort = $aboPakketAboSoort;
        return $this;
    }
    /**
     * Add item to aboPakketAboSoort value
     * @throws \InvalidArgumentException
     * @param \WebApiV4\StructType\AboPakketAboSoortV4 $item
     * @return \WebApiV4\StructType\AboPakketAboSoortInfoV4
     */
    public function addToAboPakketAboSoort(\WebApiV4\StructType\AboPakketAboSoortV4 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \WebApiV4\StructType\AboPakketAboSoortV4) {
            throw new \InvalidArgumentException(sprintf('The aboPakketAboSoort property can only contain items of type \WebApiV4\StructType\AboPakketAboSoortV4, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->aboPakketAboSoort[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \WebApiV4\StructType\AboPakketAboSoortInfoV4
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
